=== debian/watch ===
version=4
opts="pgpsigurlmangle=s%$%.asc%" \
https://www.libssh.org/files/([\d\.]+)/libssh-@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
